unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  Data.Bind.EngExt, FMX.Bind.DBEngExt, System.Rtti, System.Bindings.Outputs,
  FMX.Bind.Editors, Data.Bind.Components, FMX.StdCtrls, FMX.Effects,
  FMX.Filter.Effects, FMX.Ani, FMX.Objects, FMX.Menus, FMX.ListView.Types,
  FMX.ListView, System.TypInfo, FMX.Layouts, FMX.ListBox;

type
  TForm1 = class(TForm)
    BlurTransitionEffect1: TBlurTransitionEffect;
    Image1: TImage;
    Timer1: TTimer;
    BandedSwirlTransitionEffect1: TBandedSwirlTransitionEffect;
    MainMenu1: TMainMenu;
    BlindTransitionEffect1: TBlindTransitionEffect;
    CircleTransitionEffect1: TCircleTransitionEffect;
    MagnifyTransitionEffect1: TMagnifyTransitionEffect;
    CrumpleTransitionEffect1: TCrumpleTransitionEffect;
    DissolveTransitionEffect1: TDissolveTransitionEffect;
    DropTransitionEffect1: TDropTransitionEffect;
    FadeTransitionEffect1: TFadeTransitionEffect;
    BrightTransitionEffect1: TBrightTransitionEffect;
    PixelateTransitionEffect1: TPixelateTransitionEffect;
    WiggleTransitionEffect1: TWiggleTransitionEffect;
    ShapeTransitionEffect1: TShapeTransitionEffect;
    RippleTransitionEffect1: TRippleTransitionEffect;
    RotateCrumpleTransitionEffect1: TRotateCrumpleTransitionEffect;
    SaturateTransitionEffect1: TSaturateTransitionEffect;
    SlideTransitionEffect1: TSlideTransitionEffect;
    SwirlTransitionEffect1: TSwirlTransitionEffect;
    WaterTransitionEffect1: TWaterTransitionEffect;
    WaveTransitionEffect1: TWaveTransitionEffect;
    LineTransitionEffect1: TLineTransitionEffect;
    FloatAnimation1: TFloatAnimation;
    ListView1: TListView;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    ComboBox1: TComboBox;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListView1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FloatAnimation1Finish(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
  private
    progress: Boolean;
    { private 錾 }
  public
    { public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

uses Unit2;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
  s: TListViewItem;
begin
  if OpenDialog1.Execute = true then
  begin
    ListView1.Items.Clear;
    for i := 0 to OpenDialog1.Files.Count - 1 do
    begin
      s := ListView1.Items.Add;
      s.Text := ExtractFileName(OpenDialog1.Files[i]);
      s.Detail := OpenDialog1.Files[i];
      s.Bitmap.LoadFromFile(OpenDialog1.Files[i]);
    end;
    if ListView1.ItemCount > 0 then
    begin
      ListView1.ItemIndex := 0;
      Image1.Bitmap.Assign(ListView1.Items[0].Bitmap);
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  s: TFmxObject;
  i: Integer;
begin
  if (ListView1.ItemIndex > -1) and
    (ListView1.ItemIndex < ListView1.ItemCount - 1) then
  begin
    if FloatAnimation1.Running = true then
    begin
      progress := true;
      FloatAnimation1.Stop;
    end;
    for i := 0 to Image1.ChildrenCount - 1 do
      if Image1.Children[i].ClassName = ComboBox1.Items[ComboBox1.ItemIndex]
      then
      begin
        s := Image1.Children[i];
        FloatAnimation1.Parent := s;
        (s as TEffect).Enabled:=true;
        SetObjectProp(s, 'target',
          ListView1.Items[ListView1.ItemIndex + 1].Bitmap);
        FloatAnimation1.Start;
        break;
      end;
  end;
end;

procedure TForm1.FloatAnimation1Finish(Sender: TObject);
begin
  (FloatAnimation1.Parent as TEffect).Enabled := false;
  if (ListView1.ItemIndex < ListView1.ItemCount - 1) and (progress = false) then
  begin
    ListView1.ItemIndex := ListView1.ItemIndex + 1;
    Image1.Bitmap.Assign(ListView1.Items[ListView1.ItemIndex].Bitmap);
    if ListView1.ItemIndex < ListView1.ItemCount - 1 then
    begin
      ComboBox1.ItemIndex := Random(ComboBox1.Items.Count);
      Button2Click(Sender);
    end;
  end
  else
    progress := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to Image1.ChildrenCount - 1 do
    ComboBox1.Items.Add(Image1.Children[i].ClassName);
  ComboBox1.ItemIndex := 0;
end;

procedure TForm1.ListView1Change(Sender: TObject);
begin
  if FloatAnimation1.Running = true then
  begin
    progress := true;
    FloatAnimation1.Stop;
  end;
  Image1.Bitmap.Assign(ListView1.Items[ListView1.ItemIndex].Bitmap);
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.MenuItem8Click(Sender: TObject);
begin
  if Form2.ShowModal = mrOK then
    ComboBox1.Items.Assign(Form2.ListBox2.Items);
end;

end.
